/*
 * Copyright Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package pub.devrel.easygoogle.gcm;

import android.content.Intent;
import android.util.Log;

import com.google.android.gms.iid.InstanceIDListenerService;

/**
 * Trampoline service to launch {@link IDRegisterService} when a token refresh is needed.
 */
public class IDListenerService extends InstanceIDListenerService {
    private static final String TAG = "IDListenerService";

    public IDListenerService() {}

    /**
     * Called if InstanceID token is updated. This may occur if the security of
     * the previous token had been compromised. This call is initiated by the
     * InstanceID provider.
     */
    @Override
    public void onTokenRefresh() {
        Log.d(TAG, "onTokenRefresh");

        // TODO(samstern): I might not even need this class at all, it does not seem to do anything
        // that I can't do directly in IDRegisterService (or vice versa).
        Intent intent = new Intent(this, IDRegisterService.class);
        startService(intent);
    }
}
